# VLSI SAPD Documentation

Presentation | AGDS | CIF | DTR | OPENCHAMS | SPICE | Links & Contact

Public Member Functions | Static Public Member Functions
Circuit Class Reference

## Public Member Functions

void | addInclude (std::string)
| adds an include to the circuit. More...
void | addInstance (Instance *)
| adds an instance to the circuit. More...
void | addLibrary (std::string file, std::string type="")
| adds a library to the circuit. More...
void | addOption (std::string, std::string)
| adds an option to the circuit. More...
void | addParameter (std::string, std::string)
| adds a parameter to the circuit. More...
void | addSource (Source *)
| adds a source to the circuit. More...
Subckt * | addSubckt (std::string)
| adds a subcircuit to the circuit. More...
| Circuit ()
| creates a new circuit
const string_vector & | getIncludes ()
| returns the includes of the circuit.
const std::vector< Instance * > & | getInstances ()
| returns the instances of the circuit.
const strpair_vector & | getLibraries ()
| returns the libraries of the circuit.
const strings_map & | getOptions ()
| returns the options of the circuit.
const strings_map & | getParameters ()
| returns all circuit's parameters. More...
const std::vector< Source * > & | getSources ()
| returns the sources of the circuit.
const std::vector< Subckt * > & | getSubckts ()
| returns the subckts of the circuit.
std::string | getTitle ()
| returns the title of the circuit.
void | setTitle (std::string)
| sets the title of the circuit. More...

## Static Public Member Functions

static Circuit * | readFromFile (const std::string &)
| creates and returns a Circuit object based on a database source file. More...

## Detailed Description

This class is the root class which means that having this object in hand allows to get/set any information contained in the Spice file parsed/drived.

## Member Function Documentation

## ◆ addInclude()

void addInclude | ( | std::string | include | ) |

inline

adds an include to the circuit.

Parameters

  include | the include to add.

## ◆ addInstance()

void addInstance | ( | Instance * | instance | ) |

inline

adds an instance to the circuit.

Parameters

  instance | the instance to add.

## ◆ addLibrary()

void addLibrary | ( | std::string | file,
|  | std::string | type = `""`
| ) |  |

inline

adds a library to the circuit.

Parameters

  file | the file describing the library to add.
  type | the type if several exist in the same file (this argument is optionnal)

## ◆ addOption()

void addOption | ( | std::string | name,
|  | std::string | value
| ) |  |

adds an option to the circuit.

Parameters

  name | the name of the option.
  value | the value of the option.

Note
  The value is represented as a std::string to keep the optionnal unity.

## ◆ addParameter()

void addParameter | ( | std::string | name,
|  | std::string | value
| ) |  |

inline

adds a parameter to the circuit.

adds an equation parameter to the circuit.

Parameters

  name | the name of the parameter.
  value | the value of the parameter.
  name | the name of the parameter.
  equation | the equation string of the parameter.
  name | the name of the parameter.
  value | the value of the parameter.

Note
  The value is represented as a std::string to keep the optionnal unity.

## ◆ addSource()

void addSource | ( | Source * | source | ) |

inline

adds a source to the circuit.

Parameters

  source | the source to add.

## ◆ addSubckt()

Subckt * addSubckt | ( | std::string | name | ) |

adds a subcircuit to the circuit.

Parameters

  name | the name of the subckt.

Returns
  the newly created Subckt.

## ◆ getParameters()

const Circuit::strings_map & getParameters | ( |  | ) |

inline

returns all circuit's parameters.

returns the parameters of the circuit.

## ◆ readFromFile()

Circuit * readFromFile | ( | const std::string & | filename | ) |

static

creates and returns a Circuit object based on a database source file.

Parameters

  filePath | the source file name.

Returns
  the newly created Circuit.

## ◆ setTitle()

void setTitle | ( | std::string | title | ) |

inline

sets the title of the circuit.

Parameters

  title | the title of the circuit